#ifndef CAMERA_H
#define CAMERA_H

#include "../math/Plane3D.h"
#include "../math/Vector3D.h"
#include "../math/Matrix3D.h"
#include "../math/Matrix3DStack.h"

class Shader
{
public:
    Shader();
    
    void pop();
    void push();
    void setToIdentity();
    void scale(float sx, float sy, float sz);
    void translate(float tx, float ty, float tz);
    void translateX(float tx);
    void translateY(float ty);
    void translateZ(float tz);
    void translateTo(float tx, float ty, float tz);
    void rotateX(float degrees);
    void rotateY(float degrees);
    void rotateZ(float degrees);
    
    const float* getModelMatrix();

private:
    Matrix3DStack model;
};

#endif

